******************************************************************
**								**
**		S-RAM Read And Write tool	ver0.1		**
**								**
**						by ӂȂۂ	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
;	.include	CONST.H

SPACE	equ	$20
TAB	equ	$09
CR	equ	$0d
LF	equ	$0a

	.cpu	68000

	.text
	.even


	lea.l	MYSP(pc),sp		*X^bN|Cgw̃AhX


**********************************************************
**		Comand Line Option Check		**
**********************************************************

C_CHECK:
	addq.l	#1,a2
	bsr	SKIPSP		*Xy[XXLbv
	tst.b	(a2)		*邩H
	beq	USAGE		*Ȃ USAGE

	cmpi.b	#'-',(a2)
	beq	OP_CHECK
	cmpi.b	#'/',(a2)
	beq	OP_CHECK
	bra	USAGE		*Optionł

OP_CHECK:
	addq.l	#1,a2		*"/""-"̕a2i߂Ă
	move.b	(a2)+,d0	*ꕶo
	bsr	TOUPPER		*啶ɕϊĂ
	cmpi.b	#"R",d0
	beq	A_FILE_READ
	cmpi.b	#"W",d0
	beq	A_FILE_WRITE
	bra	USAGE		*Optionł

A_FILE_WRITE:
	clr.l	d3				*WRITE̎d3=$00.l
	bra	FILE_NAME_CHECK

A_FILE_READ:
	moveq.l	#$FF,d3				*READ̎d3=$FF
	bra	FILE_NAME_CHECK


SKIPSP0:	addq.l	#1,a2

SKIPSP:
	cmpi.b	#SPACE,(a2)		*
	beq	SKIPSP0
	cmpi.b	#TAB,(a2)		*space&tab͔΂
	beq	SKIPSP0
	rts

TOUPPER:
	cmpi.b	#"a",d0			*Ȃ啶
	bcs	TOUPPER0
	cmpi.b	#"z"+1,d0
	bcc	TOUPPER0
	subi.b	#$20,d0
TOUPPER0:
	rts


FILE_NAME_CHECK:

	lea.l	FILENAME(pc),a0

	tst.b	(a2)		*t@C
	beq	NOFILENAME

;----
	bra	GETARG0
@@:
	addq.l	#1,a2
;----

GETARG0:
	tst.b	(a2)		*̏I[R[hH
	beq	GETARG1

	cmpi.b	#SPACE,(a2)	*
;	beq	GETARG1
	beq	@b
	cmpi.b	#TAB,(a2)	*space&tab͔΂
;	beq	GETARG1
	beq	@b
	move.b	(a2)+,(a0)+	*ȏオ܂œ]JԂ
	bra	GETARG0

GETARG1:
	clr.b	(a0)		*I[R[h

	tst.b	d3
	beq	WRITE_SRAM
	bra	READ_SRAM

NOFILENAME:
	tst.b	d3
	beq	WRITE_SRAM

	lea.l	DEFO_NAME(pc),a3
	lea.l	FILENAME(pc),a4

LP:
	tst.b	(a3)		*̏I[R[hH
	beq	READ_SRAM
	move.b	(a3)+,(a4)+	*ȏオ܂œ]JԂ
	bra	LP


**********************************************************
**		READ SRAM-DATA for SRAM			**
**********************************************************

READ_SRAM:
		clr.l	-(sp)
		DOS	__SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE		* sspҔ
		addq.l	#4,sp

	movea.l	#$00ED0000,a0
	lea.l	SRAM_BUFF(pc),a1

LOOP_W:
	move.l	(a0)+,d0
	move.l	d0,(a1)+

	cmpa.l	#$00ED4000,a0
	bne	LOOP_W

		move.l	SSP_SAVE(pc),-(sp)	*
		DOS	__SUPER			* [U[[h
		addq.l	#4,sp			*


	move.w	#$0020,-(sp)
	pea.l	FILENAME(pc)
	DOS	__NEWFILE
	addq.l	#6,sp

		tst.l	d0
		bmi	NEWFILE_ERR

	move.w	#0001,-(sp)
	pea.l	FILENAME(pc)
	DOS	__OPEN			*$FF3D
	addq.l	#6,sp

		tst.l	d0
		bmi	OPEN_ERR

	move.l	d0,FILE_HANDLE

	move.l	#$0000_4000,-(sp)
	pea.l	SRAM_BUFF(pc)
	move.w	d0,-(sp)
	DOS	__WRITE			*$FF40
	lea	10(sp),sp

		tst.l	d0
		bmi	WRITE_ERR

	move.l	FILE_HANDLE(pc),d1
	move.w	d1,-(sp)
	DOS	__CLOSE			*$FF3E
	addq.l	#2,sp

	pea.l	USAGE_MSG(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp


	pea.l	DONE_READ_SRAM_MSG(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	FILENAME(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	DONE_SRAM_MSG2(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	DONE_READ_SRAM_MSG3(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	FILENAME(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	DONE_READ_SRAM_MSG4(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp

	bra	END


**********************************************************
**		 WRITE SRAM-DATA to SRAM		**
**********************************************************

WRITE_SRAM:

		clr.l	-(sp)
		DOS	__SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE		* sspҔ
		addq.l	#4,sp

	move.b	$00E8E00D,d2		*$E8E00D.b̕ۑ
	move.b	#$31,$00E8E00D		*S-RAM݉\


	move.w	#0,-(sp)
	pea.l	FILENAME(pc)		*t@C
	DOS	__OPEN			*open
	addq.l	#6,sp

	tst.l	d0
	bmi	OPEN_ERR

	move.w	d0,FILE_HANDLE	*t@Chandle֕ۑ

	move.l	#$4000,-(sp)
	pea.l	SRAM_BUFF(pc)
	move.w	FILE_HANDLE(pc),-(sp)
	DOS	__READ
	lea.l	10(sp),sp

	move.l	FILE_HANDLE(pc),d1
	move.w	d1,-(sp)
	DOS	__CLOSE			*$FF3E
	addq.l	#2,sp


	lea.l	SRAM_BUFF(pc),a0
	movea.l	#$00ED0000,a1


LOOP_R:
	move.l	(a0)+,d0
	move.l	d0,(a1)+

	cmpa.l	#$00ED4000,a1
	bne	LOOP_R

	move.b	d2,$00E8E00D		*$E8E00D.b߂

		move.l	SSP_SAVE(pc),-(sp)	*
		DOS	__SUPER			* [U[[h
		addq.l	#4,sp			*

	pea.l	USAGE_MSG(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp

	pea.l	DONE_WRITE_SRAM_MSG(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	FILENAME(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	DONE_SRAM_MSG2(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	FILENAME(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	DONE_WRITE_SRAM_MSG3(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp

	bra	END

**********************************************************
**			͕\			**
**********************************************************

USAGE:
	pea.l	USAGE_MSG(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp
	pea.l	USAGE_MSG2(pc)
	DOS	__PRINT			*$FF09
	addq.l	#4,sp

	bra	END

NEWFILE_ERR:
	pea.l	NEWFILE_ERR_MSG(pc)
	bra	DISP_ABORT

OPEN_ERR:
	pea.l	OPEN_ERR_MSG(pc)
	bra	DISP_ABORT

WRITE_ERR:
	pea.l	WRITE_ERR_MSG(pc)
	bra	DISP_ABORT


DISP_ABORT:
	DOS	__PRINT			*$FF09
	addq.l	#4,sp

END:
	DOS	__EXIT



DEFO_NAME:		.dc.b	'sram.dat',0

DONE_WRITE_SRAM_MSG:	.dc.b	'It was WRITTEN SRAM DATA for "',0
DONE_SRAM_MSG2:		.dc.b	'".',CR,LF,TAB,0
DONE_WRITE_SRAM_MSG3:	.dc.b	'  SRAM',CR,LF,0

DONE_READ_SRAM_MSG:	.dc.b	'It was READ SRAM DATA to "',0
DONE_READ_SRAM_MSG3:	.dc.b	'SRAM  ',0
DONE_READ_SRAM_MSG4:	.dc.b	CR,LF,0


USAGE_MSG:		.dc.b	'S-RAM Read And Writing tool ver.0.1p',CR,LF
			.dc.b	'	Programed by ӂȂۂ   September 2 1996',CR,LF
			.dc.b	'	 Modified by Ȃ February 12 1998',CR,LF
			.dc.b	CR,LF,0
USAGE_MSG2:
			.dc.b	'	-Rfilename	READ : SRAM  filename',CR,LF
			.dc.b	'	-Wfilename	WRITE: SRAM  filename',CR,LF,0

OPEN_ERR_MSG:		.dc.b	'Can not OPEN SRAM-DATA-FILE !',CR,LF,0
NEWFILE_ERR_MSG:	.dc.b	'Can not CREATE SRAM-DATA-FILE !',CR,LF,0
WRITE_ERR_MSG:		.dc.b	'Can not WRITE SRAM-DATA-FILE !',CR,LF,0


	.bss
	.even

SSP_SAVE:		.ds.l	1
FILE_HANDLE:		.ds.l	1
FILENAME:		.ds.b	256
SRAM_BUFF:		.ds.b	$4000

	.stack
	.even

MYSTACK:
	.ds.l	256		*X^bN̈
MYSP:

	.end
